﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication18
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            for (int i = 0; i < 12; i++)
            {
                this.ultraDataSource1.Rows.Add(new object[] { i % 4, "Row " + i.ToString() });
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            layout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.OutlookGroupBy;
            band.SortedColumns.Add("Column 0", false, true);
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            string filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xlsx");
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, filename);
            Process.Start(filename);
        }

        bool lastRowWasGroupByRow = false;

        private void ultraGridExcelExporter1_RowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventArgs e)
        {
            this.lastRowWasGroupByRow = e.GridRow.IsGroupByRow;
            Debug.WriteLine(e.CurrentRowIndex, "ED:" + e.GridRow.IsGroupByRow.ToString());
        }

        private void ultraGridExcelExporter1_RowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportingEventArgs e)
        {
            if (this.lastRowWasGroupByRow)
                e.CurrentRowIndex--;            

            if (e.GridRow.IsGroupByRow &&
                false == this.lastRowWasGroupByRow &&
                e.CurrentRowIndex > 0)
            {
                e.CurrentRowIndex--;
            }            
        }

        private void ultraGridExcelExporter1_HeaderRowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventArgs e)
        {
            if (this.lastRowWasGroupByRow)
                e.CurrentRowIndex--;
        }

        private void ultraGridExcelExporter1_SummaryRowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.SummaryRowExportedEventArgs e)
        {
            this.lastRowWasGroupByRow = false;
        }

        private void ultraGridExcelExporter1_HeaderRowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportedEventArgs e)
        {
            this.lastRowWasGroupByRow = false;
        }
    }
}
